import { faSpinner } from '@fortawesome/free-solid-svg-icons';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { NextPage } from 'next';
import Head from 'next/head';
import Router from 'next/router';
import React, { useRef, useState } from 'react';
import { useForm } from 'react-hook-form';
import useSWR from 'swr';
import InputCustom from '../components/InputCustom';
import AuthService from '../lib/api/auth';
import storage from '../utils/storage';
import ToastHelper from '../utils/toast';

const Signup: NextPage = () => {
  const { data: user } = useSWR('user', storage);
  if (user) Router.push('/');
  const {
    register,
    handleSubmit,
    formState: { errors },
    watch,
  } = useForm();
  const password = useRef({});
  password.current = watch("password", "");
  const [loading, setLoading] = useState(false);
  const submitRegister = async (req: any) => {
    setLoading(true);
    const { username, password, email } = req;
    const { data, status } = await AuthService.register({ username, password, email });
    if (status != 200) {
      ToastHelper.error({ title: data.error.message });
    } else {
      ToastHelper.success({ title: 'Sign up Success' });
      Router.push('/login');
    }
    setLoading(false);
  };

  return (
    <div>
      <Head>
        <title>Sign up | Movie Watchlist</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <div className="flex flex-col my-20">
        <div className="grid place-items-center mx-2 my-20 sm:my-auto">
          <div
            className="w-11/12 p-12 sm:w-8/12 md:w-6/12 lg:w-5/12 2xl:w-4/12 
              px-6 py-10 sm:px-10 sm:py-6 
              bg-white rounded-lg shadow-md lg:shadow-lg"
          >
            <h2 className="text-center font-semibold text-3xl lg:text-4xl text-gray-800">
              Login
              </h2>

            <form className="mt-10" onSubmit={handleSubmit(submitRegister)}>
              <div className="form-group mb-4">
                <InputCustom
                  title="Email"
                  type="text"
                  placeholder="Enter email"
                  registerField={register('email', {
                    required: 'Email required',
                    pattern: {
                      value: /^\S+@\S+$/i,
                      message: 'Please email pattern (ex: test@mail.com)',
                    },
                  })}
                  errors={errors.email}
                />
              </div>
              <div className="form-group mb-4">
                <InputCustom
                  title="Username"
                  type="text"
                  placeholder="Enter Username"
                  registerField={register('username', {
                    required: 'Username required',
                  })}
                  errors={errors.username}
                />
              </div>
              <div className="form-group mb-4">
                <InputCustom
                  title="Password"
                  type="password"
                  placeholder="Enter password"
                  registerField={register('password', {
                    required: 'Password required',
                  })}
                  errors={errors.password}
                />
              </div>
              <div className="form-group mb-4">
                <InputCustom
                  title="Confirm Password"
                  type="password"
                  placeholder="Enter password"
                  registerField={register("confirmPassword", {
                    required: "Confirm password is required.",
                    validate: value => value === password.current || "The passwords do not match"
                  })}
                  errors={errors.confirmPassword}
                />
              </div>

              <button
                type="submit"
                disabled={loading}
                className="w-full py-3 bg-purple-800 rounded-sm
                      font-medium text-white uppercase
                      focus:outline-none hover:bg-green-700 hover:shadow-none"
              >
                {loading ? (
                  <FontAwesomeIcon icon={faSpinner} className="spinner" size="sm" />
                ) : (
                  'Sign up'
                )}
              </button>

              <div className="sm:flex sm:flex-wrap mt-8 sm:mb-4 text-sm text-center">
                <a href="forgot-password" className="flex-2 underline">
                  Forgot password?
                </a>
                <p className="flex-1 text-gray-500 text-md mx-4 my-1 sm:my-auto">
                  or
                </p>
                <a href="/login" className="flex-2 underline">
                  Log in
                </a>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  )
};

export default Signup;
